/*
shorten_line_selection.jsx
選択したテキスト部分を変形（長体・平体）させて、指定ライン数以内に収めます。

2010-02-10	ver.0.1	とりあえず
2010-02-15	ver.0.2	my_line_limitに「-1」を指定すると、常に-1ラインにするようにした。
*/

//////////////////////////////////////////// 設定
var my_scale_limit = 70;//文字変形の限界値（%）
var my_line_limit = -1;//何ライン以内に収めるか。-1を指定すると、常に現状よりも-1ラインとなる。-2は無効。

////////////////////////////////////////////エラー処理 
function myerror(mess) { 
  if (arguments.length > 0) { alert(mess); }
  exit();
}



////////////////////////////////////////////文字の変形メソッド
////my_target_obj（テキストオブジェクト）を、最大my_scale_limit_num（%）まで変形して、my_line_limit_num（行）以内に収める
function set_scale(my_target_obj, my_line_limit_num, my_scale_limit_num) {
var tmp_org_scale, w;
	if (my_target_obj.parentStory.storyPreferences.storyOrientation === StoryHorizontalOrVertical.HORIZONTAL) {//横組み
		if (my_target_obj.lines.length > my_line_limit_num) {
			tmp_org_scale = my_target_obj.horizontalScale;
			for (w=tmp_org_scale; w >= my_scale_limit_num; w--){
				my_target_obj.horizontalScale = w;
				my_target_obj.recompose();//文字列の再描画
				if (my_target_obj.lines.length === my_line_limit_num) {break}//ライン行数が既定以内になったらやめる
				if ((w === my_scale_limit_num ) && (my_target_obj.lines.length > my_line_limit_num)) {//既定値まで頑張ったけれど行数を代えられなかった時
				my_target_obj.horizontalScale = tmp_org_scale;
				}
			}
		}
	} else if (my_target_obj.parentStory.storyPreferences.storyOrientation === StoryHorizontalOrVertical.VERTICAL) {//縦組み
		if (my_target_obj.lines.length > my_line_limit_num) {
			tmp_org_scale = my_target_obj.verticalScale;
			for (w=tmp_org_scale; w >= my_scale_limit_num; w--){
				my_target_obj.verticalScale = w;
				my_target_obj.recompose();//文字列の再描画
				if (my_target_obj.lines.length === my_line_limit_num) {break}//ライン行数が既定以内になったらやめる
				if ((w === my_scale_limit_num ) && (my_target_obj.lines.length > my_line_limit_num)) {//既定値まで頑張ったけれど行数を代えられなかった時
				my_target_obj.verticalScale = tmp_org_scale;
				}
			}
		}
	}
}


////////////////////////////////////////////実行処理
if (app.documents.length == 0) {myerror("ドキュメントが開かれていません")}
var my_document = app.documents[0];
if (my_document.selection.length !== 1) {myerror("テキストを一カ所だけ選択してください")}
var my_selection = my_document.selection[0];
var my_class =my_selection.reflect.name;
my_class = "Text, TextColumn, Story, Paragraph, Line, Word, Character, TextStyleRange".match(my_class);
if (my_class === null) {myerror("テキストを選択してください")}

//my_line_limitに-1が指定されていた
if (my_line_limit === -1) {
	my_line_limit = my_selection.lines.length - 1;
	if(my_line_limit < 1) {myerror()}//１行以上は詰められないので終了
}

//変形処理
set_scale(my_selection, my_line_limit, my_scale_limit);//ファンクション呼び出し
